/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

Function Library

*/


// load user's password
function nuLoadPass(ahost) {
	var passManInt = Components.classes['@mozilla.org/passwordmanager;1'].getService().QueryInterface(Components.interfaces.nsIPasswordManagerInternal);
	var fhost = {value: ''};
	var fuser = {value: ''};
	var fpassword = {value: ''};

	try {
	passManInt.findPasswordEntry(ahost, '', '', fhost, fuser, fpassword);
	} catch(e) { dump(e); }

	return [fhost.value, fuser.value, fpassword.value];
}

// save user's password
function nuSavePass(ahost, ausername, apassword) {
	var passMan = this.Components.classes['@mozilla.org/passwordmanager;1'].getService().QueryInterface(this.Components.interfaces.nsIPasswordManager);

	try {
		var todel = nuLoadPass(ahost);
		while (todel[1] != '') {
			passMan.removeUser(ahost, todel[1]);
			todel = LoadPass(ahost);
		}

	} catch(e) { dump(e); }
	passMan.addUser(ahost, ausername, apassword);
}

// encode base64 for username/password auth - func obtained from usenet
function nuEncodeBase64(Str) {

var base64 = [
'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',   //  0 to  7
'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',   //  8 to 15
'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',   // 16 to 23
'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',   // 24 to 31
'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',   // 32 to 39
'o', 'p', 'q', 'r', 's', 't', 'u', 'v',   // 40 to 47
'w', 'x', 'y', 'z', '0', '1', '2', '3',   // 48 to 55
'4', '5', '6', '7', '8', '9', '+', '/' ]; // 56 to 63

    var charCodes = new Array();
    var encStr = "";

    for (var i = 0; i < Str.length; i += 3) {
        /* grab groups of three characters, 24 bits, then split into
           4 groups of 6 bits, and use each group as an index into
           base64[] to get the encoded character */

        /* bits24 is 3 groups of 8-bit characters */
        var bits24  = ( Str.charCodeAt(i)     ) <<  16;

        if ( Str.substr(i + 1, i + 2) ) {
            bits24 |= ( Str.charCodeAt(i + 1) ) <<   8;
        }
        else {
            bits24 |= ( 0 )                     <<   8;
        }

        if ( Str.substr(i + 2, i + 3) ) {
            bits24 |= ( Str.charCodeAt(i + 2) ) <<   0;
        }
        else {
            bits24 |= ( 0 )                     <<   0;
        }

        encStr += base64[ (bits24 >>> 18) & 0x3F ];

        if ( (bits24 >>> 12) & 0x3F ) {
            encStr += base64[ (bits24 >>> 12) & 0x3F ];
        }
        else {
            encStr += '=';
        }

        if ( (bits24 >>> 6) & 0x3F ) {
            encStr += base64[ (bits24 >>>  6) & 0x3F ];
        }
        else {
            encStr += '=';
        }

        if ( (bits24 >>> 0) & 0x3F ) {
            encStr += base64[ (bits24 >>>  0) & 0x3F ];
        }
        else {
            encStr += '=';
        }
   }
   return encStr;

}

function inset(c, set) {
	return (c | set == set);
}

